if (!defined &_SYS_STROPTS_H) {
    eval 'sub _SYS_STROPTS_H {1;}';
    require 'sys/types.ph';
    require 'sys/conf.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub SNDZERO {0x001;}';
    eval 'sub SNDPIPE {0x002;}';
    eval 'sub RNORM {0x000;}';
    eval 'sub RMSGD {0x001;}';
    eval 'sub RMSGN {0x002;}';
    eval 'sub RMODEMASK {0x003;}';
    eval 'sub RPROTDAT {0x004;}';
    eval 'sub RPROTDIS {0x008;}';
    eval 'sub RPROTNORM {0x010;}';
    eval 'sub RPROTMASK {0x01c;}';
    eval 'sub RERRNORM {0x001;}';
    eval 'sub RERRNONPERSIST {0x002;}';
    eval 'sub RERRMASK {( &RERRNORM| &RERRNONPERSIST);}';
    eval 'sub WERRNORM {0x004;}';
    eval 'sub WERRNONPERSIST {0x008;}';
    eval 'sub WERRMASK {( &WERRNORM| &WERRNONPERSIST);}';
    eval 'sub FLUSHR {0x01;}';
    eval 'sub FLUSHW {0x02;}';
    eval 'sub FLUSHRW {0x03;}';
    eval 'sub FLUSHBAND {0x04;}';
    eval 'sub S_INPUT {0x0001;}';
    eval 'sub S_HIPRI {0x0002;}';
    eval 'sub S_OUTPUT {0x0004;}';
    eval 'sub S_MSG {0x0008;}';
    eval 'sub S_ERROR {0x0010;}';
    eval 'sub S_HANGUP {0x0020;}';
    eval 'sub S_RDNORM {0x0040;}';
    eval 'sub S_WRNORM { &S_OUTPUT;}';
    eval 'sub S_RDBAND {0x0080;}';
    eval 'sub S_WRBAND {0x0100;}';
    eval 'sub S_BANDURG {0x0200;}';
    eval 'sub RS_HIPRI {0x01;}';
    eval 'sub STRUIO_POSTPONE {0x08;}';
    eval 'sub MSG_HIPRI {0x01;}';
    eval 'sub MSG_ANY {0x02;}';
    eval 'sub MSG_BAND {0x04;}';
    eval 'sub MORECTL {1;}';
    eval 'sub MOREDATA {2;}';
    eval 'sub MUXID_ALL {(-1);}';
    eval 'sub ANYMARK {0x01;}';
    eval 'sub LASTMARK {0x02;}';
    eval 'sub STR {(ord(\'S\')<<8);}';
    eval 'sub I_NREAD {( &STR|01);}';
    eval 'sub I_PUSH {( &STR|02);}';
    eval 'sub I_POP {( &STR|03);}';
    eval 'sub I_LOOK {( &STR|04);}';
    eval 'sub I_FLUSH {( &STR|05);}';
    eval 'sub I_SRDOPT {( &STR|06);}';
    eval 'sub I_GRDOPT {( &STR|07);}';
    eval 'sub I_STR {( &STR|010);}';
    eval 'sub I_SETSIG {( &STR|011);}';
    eval 'sub I_GETSIG {( &STR|012);}';
    eval 'sub I_FIND {( &STR|013);}';
    eval 'sub I_LINK {( &STR|014);}';
    eval 'sub I_UNLINK {( &STR|015);}';
    eval 'sub I_PEEK {( &STR|017);}';
    eval 'sub I_FDINSERT {( &STR|020);}';
    eval 'sub I_SENDFD {( &STR|021);}';
    if (defined( &_KERNEL)) {
	eval 'sub I_RECVFD {( &STR|022);}';
	eval 'sub I_E_RECVFD {( &STR|016);}';
    }
    else {
	eval 'sub I_RECVFD {( &STR|016);}';
    }
    eval 'sub I_SWROPT {( &STR|023);}';
    eval 'sub I_GWROPT {( &STR|024);}';
    eval 'sub I_LIST {( &STR|025);}';
    eval 'sub I_PLINK {( &STR|026);}';
    eval 'sub I_PUNLINK {( &STR|027);}';
    eval 'sub I_SETEV {( &STR|030);}';
    eval 'sub I_GETEV {( &STR|031);}';
    eval 'sub I_STREV {( &STR|032);}';
    eval 'sub I_UNSTREV {( &STR|033);}';
    eval 'sub I_FLUSHBAND {( &STR|034);}';
    eval 'sub I_CKBAND {( &STR|035);}';
    eval 'sub I_GETBAND {( &STR|036);}';
    eval 'sub I_ATMARK {( &STR|037);}';
    eval 'sub I_SETCLTIME {( &STR|040);}';
    eval 'sub I_GETCLTIME {( &STR|041);}';
    eval 'sub I_CANPUT {( &STR|042);}';
    eval 'sub I_SERROPT {( &STR|043);}';
    eval 'sub I_GERROPT {( &STR|044);}';
    eval 'sub _I_BIND_RSVD {( &STR|0362);}';
    eval 'sub _I_RELE_RSVD {( &STR|0363);}';
    eval 'sub INFTIM {-1;}';
    if (defined( &_KERNEL)) {
    }
    else {
    }
    if (defined &__cplusplus) {
    }
}
1;
