if (!defined &_VM_HAT_H) {
    eval 'sub _VM_HAT_H {1;}';
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'vm/faultcode.ph';
    require 'vm/devpage.ph';
    require 'sys/kstat.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub HAT_PRIVSIZ {4;}';
    if (defined &_KERNEL) {
	if (defined &notdef) {
	}
	else {
	    eval 'sub hat_asload {
	        eval "";
	    }';
	    eval 'sub hat_exec {
	        local($oas, $ostka, $stksz, $nas, $nstka, $flag) = @_;
	        eval "0";
	    }';
	}
	eval 'sub HAT_LOAD {0x00;}';
	eval 'sub HAT_LOCK {0x01;}';
	eval 'sub HAT_UNLOCK {0x02;}';
	eval 'sub HAT_NOSYNCLOAD {0x04;}';
	eval 'sub HAT_ADVLOAD {0x08;}';
	eval 'sub HAT_NOFAULT {0x10;}';
	eval 'sub HAT_FREEPP {0x20;}';
	eval 'sub HAT_RELEPP {0x40;}';
	eval 'sub HAT_NOCONSIST {0x80;}';
	eval 'sub HAT_LOADSHARED {0x100;}';
	eval 'sub HAT_KMEM {0x10000;}';
	eval 'sub HAT_DONTALLOC {0;}';
	eval 'sub HAT_ALLOC {1;}';
	eval 'sub HAT_UNLOAD {0x0;}';
	eval 'sub HAT_TMPUNLOAD {0x1;}';
	eval 'sub HAT_NOSYNCUNLOAD {0x2;}';
	eval 'sub HAT_UNLOCKUNLOAD {0x4;}';
	eval 'sub HAT_UNMAP {0x8;}';
	eval 'sub HAT_MAP {0x0;}';
	eval 'sub HAT_DONTZERO {0x0;}';
	eval 'sub HAT_ZERORM {0x1;}';
	eval 'sub HAT_STOPON_REF {0x2;}';
	eval 'sub HAT_STOPON_MOD {0x4;}';
	eval 'sub HAT_STOPON_RM {( &HAT_STOPON_REF |  &HAT_STOPON_MOD);}';
	eval 'sub HAT_DONE {0x0;}';
	eval 'sub HAT_RESTART {0x1;}';
	eval 'sub HAT_VAC_DONE {0x2;}';
	eval 'sub HAT_CACHE {0x0;}';
	eval 'sub HAT_UNCACHE {0x1;}';
	eval 'sub HAT_TMPNC {0x2;}';
	eval 'sub HAT_STRICTORDER {0x0000;}';
	eval 'sub HAT_UNORDERED_OK {0x0100;}';
	eval 'sub HAT_MERGING_OK {0x0200;}';
	eval 'sub HAT_LOADCACHING_OK {0x0300;}';
	eval 'sub HAT_STORECACHING_OK {0x0400;}';
	eval 'sub HAT_ORDER_MASK {0x0700;}';
	eval 'sub HAT_NEVERSWAP {0x0000;}';
	eval 'sub HAT_STRUCTURE_BE {0x0800;}';
	eval 'sub HAT_STRUCTURE_LE {0x1000;}';
	eval 'sub HAT_ENDIAN_MASK {0x1800;}';
	eval 'sub HATOP_ALLOC {
	    local($hat, $as) = @_;
	    eval "(*($hat)-> &hat_op-> &h_alloc)($hat, $as)";
	}';
	eval 'sub HATOP_SETUP {
	    local($as, $flag) = @_;
	    eval "(*($as)-> &a_hat-> &hat_op-> &h_setup)($as, $flag)";
	}';
	eval 'sub HATOP_FREE {
	    local($hat, $as) = @_;
	    eval "(*($hat)-> &hat_op-> &h_free)($hat, $as)";
	}';
	eval 'sub HATOP_DUP {
	    local($hat, $as, $newas) = @_;
	    eval "(*($hat)-> &hat_op-> &h_dup)($hat, $as, $newas)";
	}';
	eval 'sub HATOP_SWAPIN {
	    local($hat, $as) = @_;
	    eval "(*($hat)-> &hat_op-> &h_swapin)($hat, $as)";
	}';
	eval 'sub HATOP_SWAPOUT {
	    local($hat, $as) = @_;
	    eval "(*($hat)-> &hat_op-> &h_swapout)($hat, $as)";
	}';
	eval 'sub HATOP_MEMLOAD {
	    local($hat, $as, $addr, $pp, $prot, $flags) = @_;
	    eval "(*($hat)-> &hat_op-> &h_memload)($hat, $as, $addr, $pp, $prot, $flags)";
	}';
	eval 'sub HATOP_DEVLOAD {
	    local($hat, $as, $addr, $dp, $pf, $prot, $flags) = @_;
	    eval "(*($hat)-> &hat_op-> &h_devload)($hat, $as, $addr, $dp, $pf, $prot, $flags)";
	}';
	eval 'sub HATOP_CONTIG_MEMLOAD {
	    local($hat, $as, $addr, $pp, $prot, $flags, $len) = @_;
	    eval "(*($hat)-> &hat_op-> &h_contig_memload)($hat, $as, $addr, $pp, $prot, $flags, $len)";
	}';
	eval 'sub HATOP_CONTIG_DEVLOAD {
	    local($hat, $as, $addr, $dp, $pf, $prot, $flags, $len) = @_;
	    eval "(*($hat)-> &hat_op-> &h_contig_devload)($hat, $as, $addr, $dp, $pf, $prot, $flags, $len)";
	}';
	eval 'sub HATOP_UNLOCK {
	    local($hat, $as, $addr, $len) = @_;
	    eval "(*($hat)-> &hat_op-> &h_unlock)($hat, $as, $addr, $len)";
	}';
	eval 'sub HATOP_FAULT {
	    local($hat, $addr) = @_;
	    eval "(*($hat)-> &hat_op-> &h_fault)($hat, $addr)";
	}';
	eval 'sub HATOP_CHGPROT {
	    local($hat, $as, $addr, $len, $vprot) = @_;
	    eval "(*($hat)-> &hat_op-> &h_chgprot)($as, $addr, $len, $vprot)";
	}';
	eval 'sub HATOP_UNLOAD {
	    local($hat, $as, $addr, $len, $flags) = @_;
	    eval "(*($hat)-> &hat_op-> &h_unload)($as, $addr, $len, $flags)";
	}';
	eval 'sub HATOP_SYNC {
	    local($hat, $as, $addr, $len, $flags) = @_;
	    eval "(*($hat)-> &hat_op-> &h_sync)($as, $addr, $len, $flags)";
	}';
	eval 'sub HATOP_PAGEUNLOAD {
	    local($hat, $pp, $hme) = @_;
	    eval "(*($hat)-> &hat_op-> &h_pageunload)($pp, $hme)";
	}';
	eval 'sub HATOP_PAGESYNC {
	    local($hat, $pp, $hme, $flag) = @_;
	    eval "(*($hat)-> &hat_op-> &h_pagesync)($hat, $pp, $hme, $flag)";
	}';
	eval 'sub HATOP_PAGECACHECTL {
	    local($hsw, $pp, $flag) = @_;
	    eval "(*($hsw)-> &hsw_ops-> &h_pagecachectl)($pp, $flag)";
	}';
	eval 'sub HATOP_GETKPFNUM {
	    local($hat, $addr) = @_;
	    eval "(*($hat)-> &hat_op-> &h_getkpfnum)($addr)";
	}';
	eval 'sub HATOP_GETPFNUM {
	    local($hat, $as, $addr) = @_;
	    eval "(*($hat)-> &hat_op-> &h_getpfnum)($as, $addr)";
	}';
	eval 'sub HATOP_MAP {
	    local($hat, $as, $addr, $len, $flags) = @_;
	    eval "(*($hat)-> &hat_op-> &h_map)($hat, $as, $addr, $len, $flags)";
	}';
	eval 'sub HATOP_PROBE {
	    local($hat, $as, $addr) = @_;
	    eval "(*($hat)-> &hat_op-> &h_probe)($hat, $as, $addr)";
	}';
	eval 'sub HATOP_SHARE {
	    local($hat, $das, $daddr, $sas, $saddr, $len) = @_;
	    eval "(*($hat)-> &hat_op-> &h_share)($das, $daddr, $sas, $saddr, $len)";
	}';
	eval 'sub HATOP_UNSHARE {
	    local($hat, $as, $addr, $len) = @_;
	    eval "(*($hat)-> &hat_op-> &h_unshare)($as, $addr, $len)";
	}';
	eval 'sub HATOP_UNMAP {
	    local($hat, $as, $addr, $len, $flags) = @_;
	    eval "(*($hat)-> &hat_op-> &h_unmap)($as, $addr, $len, $flags)";
	}';
    }
    eval 'sub HRM_SHIFT {4;}';
    eval 'sub HRM_BYTES {(1 <<  &HRM_SHIFT);}';
    eval 'sub HRM_PAGES {(( &HRM_BYTES *  &NBBY) / 2);}';
    eval 'sub HRM_PGPERBYTE {( &NBBY/2);}';
    eval 'sub HRM_PGBYTEMASK {( &HRM_PGPERBYTE-1);}';
    eval 'sub HRM_PGOFFMASK {(( &HRM_PGPERBYTE-1) <<  &MMU_PAGESHIFT);}';
    eval 'sub HRM_BASEOFFSET {((( &MMU_PAGESIZE *  &HRM_PAGES) - 1));}';
    eval 'sub HRM_BASEMASK {(~( &HRM_BASEOFFSET));}';
    eval 'sub HRM_BASESHIFT {( &MMU_PAGESHIFT + ( &HRM_SHIFT + 2));}';
    eval 'sub HRM_PAGEMASK {( &MMU_PAGEMASK ^  &HRM_BASEMASK);}';
    eval 'sub HRM_HASHSIZE {0x200;}';
    eval 'sub HRM_HASHMASK {( &HRM_HASHSIZE - 1);}';
    eval 'sub HRM_BLIST_INCR {0x200;}';
    eval 'sub HRM_SWSMONID {1;}';
    if (defined &_KERNEL) {
	eval 'sub HATLOCK_PAGE_ENTER {
	    local($pp) = @_;
	    eval "(( &hat_lockops-> &hl_page_enter)($pp))";
	}';
	eval 'sub HATLOCK_PAGE_EXIT {
	    local($pp) = @_;
	    eval "(( &hat_lockops-> &hl_page_exit)($pp))";
	}';
	eval 'sub HATLOCK_HAT_ENTER {
	    local($as) = @_;
	    eval "(( &hat_lockops-> &hl_hat_enter)($as))";
	}';
	eval 'sub HATLOCK_HAT_EXIT {
	    local($as) = @_;
	    eval "(( &hat_lockops-> &hl_hat_exit)($as))";
	}';
	eval 'sub HATLOCK_MLIST_ENTER {
	    local($pp) = @_;
	    eval "(( &hat_lockops-> &hl_mlist_enter)($pp))";
	}';
	eval 'sub HATLOCK_MLIST_EXIT {
	    local($pp) = @_;
	    eval "(( &hat_lockops-> &hl_mlist_exit)($pp))";
	}';
	eval 'sub HATLOCK_MLIST_HELD {
	    local($pp) = @_;
	    eval "(( &hat_lockops-> &hl_mlist_held)($pp))";
	}';
    }
    eval 'sub HATLOCK_CACHECTL_ENTER {
        local($pp) = @_;
        eval "(( &hat_lockops-> &hl_cachectl_enter)($pp))";
    }';
    eval 'sub HATLOCK_CACHECTL_EXIT {
        local($pp) = @_;
        eval "(( &hat_lockops-> &hl_cachectl_exit)($pp))";
    }';
    if (defined &__cplusplus) {
    }
}
1;
