if (!defined &_VM_SEG_H) {
    eval 'sub _VM_SEG_H {1;}';
    require 'sys/vnode.ph';
    require 'vm/seg_enum.ph';
    require 'vm/faultcode.ph';
    require 'vm/hat.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub SSL_NLEVELS {4;}';
    eval 'sub SSL_BFACTOR {4;}';
    eval 'sub SSL_LOG2BF {2;}';
    eval 'sub SSL_UNUSED {(-1);}';
    if (defined &_KERNEL) {
	eval 'sub SEGOP_DUP {
	    local($s, $n) = @_;
	    eval "(*($s)-> &s_ops-> &dup)(($s), ($n))";
	}';
	eval 'sub SEGOP_UNMAP {
	    local($s, $a, $l) = @_;
	    eval "(*($s)-> &s_ops-> &unmap)(($s), ($a), ($l))";
	}';
	eval 'sub SEGOP_FREE {
	    local($s) = @_;
	    eval "(*($s)-> &s_ops-> &free)(($s))";
	}';
	eval 'sub SEGOP_FAULT {
	    local($h, $s, $a, $l, $t, $rw) = @_;
	    eval "(*($s)-> &s_ops-> &fault)(($h), ($s), ($a), ($l), ($t), ($rw))";
	}';
	eval 'sub SEGOP_FAULTA {
	    local($s, $a) = @_;
	    eval "(*($s)-> &s_ops-> &faulta)(($s), ($a))";
	}';
	eval 'sub SEGOP_SETPROT {
	    local($s, $a, $l, $p) = @_;
	    eval "(*($s)-> &s_ops-> &setprot)(($s), ($a), ($l), ($p))";
	}';
	eval 'sub SEGOP_CHECKPROT {
	    local($s, $a, $l, $p) = @_;
	    eval "(*($s)-> &s_ops-> &checkprot)(($s), ($a), ($l), ($p))";
	}';
	eval 'sub SEGOP_KLUSTER {
	    local($s, $a, $d) = @_;
	    eval "(*($s)-> &s_ops-> &kluster)(($s), ($a), ($d))";
	}';
	eval 'sub SEGOP_SWAPOUT {
	    local($s) = @_;
	    eval "(*($s)-> &s_ops-> &swapout)(($s))";
	}';
	eval 'sub SEGOP_SYNC {
	    local($s, $a, $l, $atr, $f) = @_;
	    eval "(*($s)-> &s_ops-> &sync)(($s), ($a), ($l), ($atr), ($f))";
	}';
	eval 'sub SEGOP_INCORE {
	    local($s, $a, $l, $v) = @_;
	    eval "(*($s)-> &s_ops-> &incore)(($s), ($a), ($l), ($v))";
	}';
	eval 'sub SEGOP_LOCKOP {
	    local($s, $a, $l, $atr, $op, $b, $p) = @_;
	    eval "(*($s)-> &s_ops-> &lockop)(($s), ($a), ($l), ($atr), ($op), ($b), ($p))";
	}';
	eval 'sub SEGOP_GETPROT {
	    local($s, $a, $l, $p) = @_;
	    eval "(*($s)-> &s_ops-> &getprot)(($s), ($a), ($l), ($p))";
	}';
	eval 'sub SEGOP_GETOFFSET {
	    local($s, $a) = @_;
	    eval "(*($s)-> &s_ops-> &getoffset)(($s), ($a))";
	}';
	eval 'sub SEGOP_GETTYPE {
	    local($s, $a) = @_;
	    eval "(*($s)-> &s_ops-> &gettype)(($s), ($a))";
	}';
	eval 'sub SEGOP_GETVP {
	    local($s, $a, $vpp) = @_;
	    eval "(*($s)-> &s_ops-> &getvp)(($s), ($a), ($vpp))";
	}';
	eval 'sub SEGOP_ADVISE {
	    local($s, $a, $l, $b) = @_;
	    eval "(*($s)-> &s_ops-> &advise)(($s), ($a), ($l), ($b))";
	}';
	eval 'sub SEGOP_DUMP {
	    local($s) = @_;
	    eval "(*($s)-> &s_ops-> &dump)(($s))";
	}';
	eval 'sub seg_page {
	    local($seg, $addr) = @_;
	    eval "(((($addr) - ($seg)-> &s_base)) >>  &PAGESHIFT)";
	}';
	eval 'sub seg_pages {
	    local($seg) = @_;
	    eval "(((($seg)-> &s_size +  &PAGEOFFSET)) >>  &PAGESHIFT)";
	}';
	if (defined &VMDEBUG) {
	}
    }
    if (defined &__cplusplus) {
    }
}
1;
