if (!defined &_SYS_FILE_H) {
    eval 'sub _SYS_FILE_H {1;}';
    require 'sys/t_lock.ph';
    if (defined &_KERNEL) {
	require 'sys/user.ph';
    }
    if (defined &__cplusplus) {
    }
    eval 'sub FOPEN {0xFFFFFFFF;}';
    eval 'sub FREAD {0x01;}';
    eval 'sub FWRITE {0x02;}';
    eval 'sub FNDELAY {0x04;}';
    eval 'sub FAPPEND {0x08;}';
    eval 'sub FSYNC {0x10;}';
    if (defined &C2_AUDIT) {
	eval 'sub FREVOKED {0x20;}';
    }
    eval 'sub FDSYNC {0x40;}';
    eval 'sub FRSYNC {0x8000;}';
    eval 'sub FNONBLOCK {0x80;}';
    eval 'sub FMASK {0x80FF;}';
    eval 'sub FCREAT {0x0100;}';
    eval 'sub FTRUNC {0x0200;}';
    eval 'sub FEXCL {0x0400;}';
    eval 'sub FNOCTTY {0x0800;}';
    eval 'sub FASYNC {0x1000;}';
    eval 'sub FOFFSET {0x2000;}';
    eval 'sub FNODSYNC {0x10000;}';
    eval 'sub FCLOSEXEC {001;}';
    eval 'sub FRESERVED {002;}';
    eval 'sub FCLOSING {004;}';
    if (defined &_KERNEL) {
	if (defined &C2_AUDIT) {
	    eval 'sub GETF {
	        local($fd) = @_;
	        eval "(( &curproc-> &p_lwptotal == 1)? (($fd) >= 0 && ($fd) <  &PTOU( &curproc)-> &u_nofiles) ? ( &audit_active)?( &audit_getf(($fd)),  &PTOU( &curproc)-> &u_flist[($fd)]. &uf_ofile) :  &PTOU( &curproc)-> &u_flist[($fd)]. &uf_ofile :  0 :  &getf(($fd)) )";
	    }';
	}
	else {
	    eval 'sub GETF {
	        local($fd) = @_;
	        eval "(( &curproc-> &p_lwptotal == 1)? (($fd) >= 0 && ($fd) <  &PTOU( &curproc)-> &u_nofiles) ?  &PTOU( &curproc)-> &u_flist[($fd)]. &uf_ofile :  0 :  &getf(($fd)) )";
	    }';
	}
	eval 'sub RELEASEF {
	    local($fd) = @_;
	    eval "{  &if ( &curproc-> &p_lwptotal > 1)  &releasef($fd); }";
	}';
	eval 'sub FKIOCTL {0x80000000;}';
	eval 'sub FKLYR {0x40000000;}';
    }
    eval 'sub NULLFP {(0);}';
    if (!defined &L_SET) {
	eval 'sub L_SET {0;}';
    }
    if (defined( &_KERNEL)) {
	if (!defined &_BOOT) {
	}
    }
    if (defined &__cplusplus) {
    }
}
1;
