if (!defined &_SYS_PROCFS_H) {
    eval 'sub _SYS_PROCFS_H {1;}';
    require 'sys/types.ph';
    require 'sys/time.ph';
    require 'sys/signal.ph';
    require 'sys/siginfo.ph';
    require 'sys/fault.ph';
    require 'sys/syscall.ph';
    require 'sys/regset.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub PIOC {(ord(\'q\')<<8);}';
    eval 'sub PIOCSTATUS {( &PIOC|1);}';
    eval 'sub PIOCSTOP {( &PIOC|2);}';
    eval 'sub PIOCWSTOP {( &PIOC|3);}';
    eval 'sub PIOCRUN {( &PIOC|4);}';
    eval 'sub PIOCGTRACE {( &PIOC|5);}';
    eval 'sub PIOCSTRACE {( &PIOC|6);}';
    eval 'sub PIOCSSIG {( &PIOC|7);}';
    eval 'sub PIOCKILL {( &PIOC|8);}';
    eval 'sub PIOCUNKILL {( &PIOC|9);}';
    eval 'sub PIOCGHOLD {( &PIOC|10);}';
    eval 'sub PIOCSHOLD {( &PIOC|11);}';
    eval 'sub PIOCMAXSIG {( &PIOC|12);}';
    eval 'sub PIOCACTION {( &PIOC|13);}';
    eval 'sub PIOCGFAULT {( &PIOC|14);}';
    eval 'sub PIOCSFAULT {( &PIOC|15);}';
    eval 'sub PIOCCFAULT {( &PIOC|16);}';
    eval 'sub PIOCGENTRY {( &PIOC|17);}';
    eval 'sub PIOCSENTRY {( &PIOC|18);}';
    eval 'sub PIOCGEXIT {( &PIOC|19);}';
    eval 'sub PIOCSEXIT {( &PIOC|20);}';
    eval 'sub PIOCSFORK {( &PIOC|21);}';
    eval 'sub PIOCRFORK {( &PIOC|22);}';
    eval 'sub PIOCSRLC {( &PIOC|23);}';
    eval 'sub PIOCRRLC {( &PIOC|24);}';
    eval 'sub PIOCGREG {( &PIOC|25);}';
    eval 'sub PIOCSREG {( &PIOC|26);}';
    eval 'sub PIOCGFPREG {( &PIOC|27);}';
    eval 'sub PIOCSFPREG {( &PIOC|28);}';
    eval 'sub PIOCNICE {( &PIOC|29);}';
    eval 'sub PIOCPSINFO {( &PIOC|30);}';
    eval 'sub PIOCNMAP {( &PIOC|31);}';
    eval 'sub PIOCMAP {( &PIOC|32);}';
    eval 'sub PIOCOPENM {( &PIOC|33);}';
    eval 'sub PIOCCRED {( &PIOC|34);}';
    eval 'sub PIOCGROUPS {( &PIOC|35);}';
    eval 'sub PIOCGETPR {( &PIOC|36);}';
    eval 'sub PIOCGETU {( &PIOC|37);}';
    eval 'sub PIOCSET {( &PIOC|38);}';
    eval 'sub PIOCRESET {( &PIOC|39);}';
    eval 'sub PIOCNWATCH {( &PIOC|40);}';
    eval 'sub PIOCGWATCH {( &PIOC|41);}';
    eval 'sub PIOCSWATCH {( &PIOC|42);}';
    eval 'sub PIOCUSAGE {( &PIOC|43);}';
    eval 'sub PIOCOPENPD {( &PIOC|44);}';
    eval 'sub PIOCLWPIDS {( &PIOC|45);}';
    eval 'sub PIOCOPENLWP {( &PIOC|46);}';
    eval 'sub PIOCLSTATUS {( &PIOC|47);}';
    eval 'sub PIOCLUSAGE {( &PIOC|48);}';
    eval 'sub PIOCNAUXV {( &PIOC|49);}';
    eval 'sub PIOCAUXV {( &PIOC|50);}';
    eval 'sub PIOCGXREGSIZE {( &PIOC|51);}';
    eval 'sub PIOCGXREG {( &PIOC|52);}';
    eval 'sub PIOCSXREG {( &PIOC|53);}';
    eval 'sub PIOCNLDT {( &PIOC|103);}';
    eval 'sub PIOCLDT {( &PIOC|104);}';
    eval 'sub prgreg_t { &greg_t;}';
    eval 'sub prgregset_t { &gregset_t;}';
    eval 'sub prfpregset_t { &fpregset_t;}';
    eval 'sub R_PC { &EIP;}';
    eval 'sub R_PS { &EFL;}';
    eval 'sub R_SP { &UESP;}';
    eval 'sub R_FP { &EBP;}';
    eval 'sub R_R0 { &EAX;}';
    eval 'sub R_R1 { &EDX;}';
    eval 'sub PRCLSZ {8;}';
    eval 'sub PRSYSARGS {8;}';
    eval 'sub PR_STOPPED {0x0001;}';
    eval 'sub PR_ISTOP {0x0002;}';
    eval 'sub PR_DSTOP {0x0004;}';
    eval 'sub PR_ASLEEP {0x0008;}';
    eval 'sub PR_FORK {0x0010;}';
    eval 'sub PR_RLC {0x0020;}';
    eval 'sub PR_PTRACE {0x0040;}';
    eval 'sub PR_PCINVAL {0x0080;}';
    eval 'sub PR_ISSYS {0x0100;}';
    eval 'sub PR_STEP {0x0200;}';
    eval 'sub PR_KLC {0x0400;}';
    eval 'sub PR_ASYNC {0x0800;}';
    eval 'sub PR_PCOMPAT {0x1000;}';
    eval 'sub PR_MSACCT {0x2000;}';
    eval 'sub PR_BPTADJ {0x4000;}';
    eval 'sub PR_ASLWP {0x8000;}';
    eval 'sub PR_REQUESTED {1;}';
    eval 'sub PR_SIGNALLED {2;}';
    eval 'sub PR_SYSENTRY {3;}';
    eval 'sub PR_SYSEXIT {4;}';
    eval 'sub PR_JOBCONTROL {5;}';
    eval 'sub PR_FAULTED {6;}';
    eval 'sub PR_SUSPENDED {7;}';
    eval 'sub PR_CHECKPOINT {8;}';
    eval 'sub PRFNSZ {16;}';
    eval 'sub PRARGSZ {80;}';
    if (!defined( &_STYPES)) {
	eval 'sub pr_ttydev { &pr_lttydev;}';
    }
    else {
	eval 'sub pr_ttydev { &pr_ottydev;}';
    }
    eval 'sub PRNODEV {( &dev_t)(-1);}';
    eval 'sub PRCSIG {0x001;}';
    eval 'sub PRCFAULT {0x002;}';
    eval 'sub PRSTRACE {0x004;}';
    eval 'sub PRSHOLD {0x008;}';
    eval 'sub PRSFAULT {0x010;}';
    eval 'sub PRSVADDR {0x020;}';
    eval 'sub PRSTEP {0x040;}';
    eval 'sub PRSABORT {0x080;}';
    eval 'sub PRSTOP {0x100;}';
    eval 'sub MA_READ {0x04;}';
    eval 'sub MA_WRITE {0x02;}';
    eval 'sub MA_EXEC {0x01;}';
    eval 'sub MA_SHARED {0x08;}';
    eval 'sub MA_BREAK {0x10;}';
    eval 'sub MA_STACK {0x20;}';
    eval 'sub PG_REFERENCED {0x02;}';
    eval 'sub PG_MODIFIED {0x01;}';
    eval 'sub PG_HWMAPPED {0x04;}';
    eval 'sub prfillset {
        local($sp) = @_;
        eval "{  &register int  &_i_ = $sizeof{*($sp})/$sizeof{\'u_long\'};  &while ( &_i_) (($sp))[-- &_i_] = 0xFFFFFFFF; }";
    }';
    eval 'sub premptyset {
        local($sp) = @_;
        eval "{  &register int  &_i_ = $sizeof{*($sp})/$sizeof{\'u_long\'};  &while ( &_i_) (($sp))[-- &_i_] = 0; }";
    }';
    eval 'sub praddset {
        local($sp, $flag) = @_;
        eval "(( &void)(((($flag)-1) < 32*$sizeof{*($sp})/$sizeof{\'u_long\'}) ? ((($sp))[(($flag)-1)/32] |= (1 &UL<<((($flag)-1)%32))) : 0))";
    }';
    eval 'sub prdelset {
        local($sp, $flag) = @_;
        eval "(( &void)(((($flag)-1) < 32*$sizeof{*($sp})/$sizeof{\'u_long\'}) ? ((($sp))[(($flag)-1)/32] &= ~(1 &UL<<((($flag)-1)%32))) : 0))";
    }';
    eval 'sub prismember {
        local($sp, $flag) = @_;
        eval "(((($flag)-1) < 32*$sizeof{*($sp})/$sizeof{\'u_long\'}) && ((($sp))[(($flag)-1)/32] & (1 &UL<<((($flag)-1)%32))))";
    }';
    if (defined &__cplusplus) {
    }
}
1;
