if (!defined &_SYS_SIGINFO_H) {
    eval 'sub _SYS_SIGINFO_H {1;}';
    require 'sys/feature_tests.ph';
    if (defined &__cplusplus) {
    }
    if (!defined( &_POSIX_C_SOURCE) || ( &_POSIX_C_SOURCE > 2) || defined( &__EXTENSIONS__)) {
	eval 'sub sigev_signo { &_sigev_un. &_sigev_signo;}';
	eval 'sub SIGEV_NONE {1;}';
	eval 'sub SIGEV_SIGNAL {2;}';
	eval 'sub SIGEV_THREAD {3;}';
	eval 'sub SI_FROMUSER {
	    local($sip) = @_;
	    eval "(($sip)-> &si_code <= 0)";
	}';
	eval 'sub SI_FROMKERNEL {
	    local($sip) = @_;
	    eval "(($sip)-> &si_code > 0)";
	}';
	eval 'sub SI_NOINFO {32767;}';
	eval 'sub SI_USER {0;}';
	eval 'sub SI_LWP {(-1);}';
	eval 'sub SI_QUEUE {(-2);}';
	eval 'sub SI_TIMER {(-3);}';
	eval 'sub SI_ASYNCIO {(-4);}';
	eval 'sub SI_MESGQ {(-5);}';
    }
    if (!defined( &_POSIX_C_SOURCE) || defined( &__EXTENSIONS__)) {
	require 'sys/machsig.ph';
	eval 'sub TRAP_BRKPT {1;}';
	eval 'sub TRAP_TRACE {2;}';
	eval 'sub NSIGTRAP {2;}';
	eval 'sub CLD_EXITED {1;}';
	eval 'sub CLD_KILLED {2;}';
	eval 'sub CLD_DUMPED {3;}';
	eval 'sub CLD_TRAPPED {4;}';
	eval 'sub CLD_STOPPED {5;}';
	eval 'sub CLD_CONTINUED {6;}';
	eval 'sub NSIGCLD {6;}';
	eval 'sub POLL_IN {1;}';
	eval 'sub POLL_OUT {2;}';
	eval 'sub POLL_MSG {3;}';
	eval 'sub POLL_ERR {4;}';
	eval 'sub POLL_PRI {5;}';
	eval 'sub POLL_HUP {6;}';
	eval 'sub NSIGPOLL {6;}';
	eval 'sub PROF_SIG {1;}';
	eval 'sub NSIGPROF {1;}';
    }
    if (!defined( &_POSIX_C_SOURCE) || ( &_POSIX_C_SOURCE > 2) || defined( &__EXTENSIONS__)) {
	eval 'sub SI_MAXSZ {128;}';
	eval 'sub SI_PAD {(( &SI_MAXSZ / $sizeof{\'int\'}) - 3);}';
	require 'sys/time.ph';
	if (!defined( &_POSIX_C_SOURCE)) {
	}
	if (!defined( &_POSIX_C_SOURCE)) {
	    eval 'sub SI_CANQUEUE {
	        local($c) = @_;
	        eval "(($c) <=  &SI_QUEUE)";
	    }';
	}
	eval 'sub si_pid { &_data. &_proc. &_pid;}';
	eval 'sub si_status { &_data. &_proc. &_pdata. &_cld. &_status;}';
	eval 'sub si_stime { &_data. &_proc. &_pdata. &_cld. &_stime;}';
	eval 'sub si_utime { &_data. &_proc. &_pdata. &_cld. &_utime;}';
	eval 'sub si_uid { &_data. &_proc. &_pdata. &_kill. &_uid;}';
	eval 'sub si_value { &_data. &_proc. &_pdata. &_kill. &_value;}';
	eval 'sub si_addr { &_data. &_fault. &_addr;}';
	eval 'sub si_trapno { &_data. &_fault. &_trapno;}';
	eval 'sub si_fd { &_data. &_file. &_fd;}';
	eval 'sub si_band { &_data. &_file. &_band;}';
	eval 'sub si_tstamp { &_data. &_prof. &_tstamp;}';
	eval 'sub si_syscall { &_data. &_prof. &_syscall;}';
	eval 'sub si_nsysarg { &_data. &_prof. &_nsysarg;}';
	eval 'sub si_sysarg { &_data. &_prof. &_sysarg;}';
	eval 'sub si_fault { &_data. &_prof. &_fault;}';
	eval 'sub si_faddr { &_data. &_prof. &_faddr;}';
	eval 'sub si_mstate { &_data. &_prof. &_mstate;}';
    }
    if (defined &__cplusplus) {
    }
}
1;
